Codeforces Round 1039 (Div. 2)
B
Deque Process
Codeforces
1100
原题
← AC →
翻译中…

We say that an array $a$ of size $n$ is bad if and only if there exists $1 \leq i \leq n - 4$ such that one of the following conditions holds:

翻译中…
  • $a_i \lt a_{i+1} \lt a_{i+2} \lt a_{i+3} \lt a_{i+4}$
  • $a_i \gt a_{i+1} \gt a_{i+2} \gt a_{i+3} \gt a_{i+4}$
翻译中…

An array is good if and only if it's not bad. For example:

翻译中…
  • $a = [3, \color{red}{1, 2, 4, 5, 6}]$ is bad because $a_2 \lt a_3 \lt a_4 \lt a_5 \lt a_6$.
  • $a = [\color{red}{7, 6, 5, 4, 1}, 2, 3]$ is bad because $a_1 \gt a_2 \gt a_3 \gt a_4 \gt a_5$.
  • $a = [7, 6, 5, 1, 2, 3, 4]$ is good.
翻译中…

You're given a permutation$^{\text{∗}}$ $p_1, p_2, \ldots, p_n$.

翻译中…

You must perform $n$ turns. At each turn, you must remove either the leftmost or the rightmost remaining element in $p$. Let $q_i$ be the element removed at the $i$-th turn.

翻译中…

Choose which element to remove at each turn so that the resulting array $q$ is good. We can show that under the given constraints, it's always possible.

翻译中…

$^{\text{∗}}$A permutation of length $n$ is an array consisting of $n$ distinct integers from $1$ to $n$ in arbitrary order. For example, $[2,3,1,5,4]$ is a permutation, but $[1,2,2]$ is not a permutation ($2$ appears twice in the array), and $[1,3,4]$ is also not a permutation ($n=3$ but there is $4$ in the array).

翻译中…

Input

翻译中…

Each test contains multiple test cases. The first line contains the number of test cases $t$ ($1 \le t \le 10\,000$). The description of the test cases follows.

翻译中…

The first line of each test case contains a single integer $n$ ($5 \leq n \leq 100\,000$) — the length of the array.

翻译中…

The second line of each test case contains $n$ integers $p_1, p_2, \ldots, p_n$ ($1 \leq p_i \leq n$, $p_i$ are pairwise distinct) — elements of the permutation.

翻译中…

It is guaranteed that the sum of $n$ over all test cases doesn't exceed $200\,000$.

翻译中…

Output

翻译中…

For each test case, you must output a string $s$ of length $n$. For every $1 \leq i \leq n$, at the $i$-th turn:

翻译中…
  • $s_i = \texttt{L}$ means that you removed the leftmost element of $p$
  • $s_i = \texttt{R}$ means that you removed the rightmost element of $p$
翻译中…

We can show that an answer always exists. If there are multiple solutions, print any of them.

翻译中…

Note

翻译中…

In the first test case, the sequence $\color{blue}{\texttt{RRR}}\color{red}{\texttt{LLLL}}$ results in $q = [\color{blue}{7}, \color{blue}{6}, \color{blue}{5}, \color{red}{1}, \color{red}{2}, \color{red}{3}, \color{red}{4}]$.

翻译中…

In the second test case, the sequence $\color{red}{\texttt{LL}}\color{blue}{\texttt{RR}}\color{red}{\texttt{LL}}\color{blue}{\texttt{RR}}\color{red}{\texttt{L}}$ results in $q = [\color{red}{1}, \color{red}{3}, \color{blue}{2}, \color{blue}{4}, \color{red}{6}, \color{red}{8}, \color{blue}{5}, \color{blue}{7}, \color{red}{9}]$.

翻译中…

样例

Input #1
6
7
1 2 3 4 5 6 7
9
1 3 6 8 9 7 5 4 2
12
1 2 11 3 6 4 7 8 12 5 10 9
6
4 1 2 5 6 3
5
1 2 3 5 4
9
5 1 8 6 2 7 9 4 3
Output #1
RRRLLLL
LLRRLLRRL
LLLLLLLLLLLL
LLLLLL
LLLLL
LLLLLLLLL
InputCopy OutputCopy
题目信息
题号
2128B
时间限制
1.5 s
内存限制
256 MB
标签
构造
贪心
排序
双指针

题面与样例版权归 Codeforces 及出题人所有;中文翻译由 AI 生成(CI 管线),如有出入请以原文为准。